﻿using UnityEngine;
using System.Collections;

public class LSFPathfinder : MonoBehaviour {

	private NavMeshAgent mNavAgent;
	private Vector3 mTarget;

	// Use this for initialization
	void Start () {
		mNavAgent = GetComponent<NavMeshAgent> ();

		mTarget = Vector3.zero;
	}

	/// <summary>
	/// Sets the target gameobject for this pathfinder (uses its position)
	/// </summary>
	/// <param name="target">Target.</param>
	public void PathTo(GameObject target)
	{
        if (target != null)
        {
            mTarget = target.transform.position;
        }
        else
        {
            mTarget = Vector3.zero;
        }
	}

	/// <summary>
	/// Sets the target for this pathfinder 
	/// </summary>
	/// <param name="target">Target.</param>
	public void PathTo(Vector3 target)
	{
		Debug.Log ("Set path");
		mTarget = target;
	}

	// Update is called once per frame
	void LateUpdate () {
		// Only set the destination once
		if (mTarget != Vector3.zero) 
		{
			mNavAgent.SetDestination(mTarget);
			mTarget = Vector3.zero;
		}
	}

    internal void Stop()
    {
        mNavAgent.Stop();
    }
}
