using UnityEngine;
using System.Collections;

[RequireComponent (typeof (LSFPlayer))]
public class LSFControllerController : MonoBehaviour {

	public int controllerId
	{
		get
		{
			return player.playerIndex + 1;
		}
	}

	const float DEAD_ZONE = .3f;
	
	LSFMover mover;

	LSFLooker looker;

	LSFPlayer player;

	void Awake()
	{
		mover = GetComponent<LSFMover>();
		looker = GetComponent<LSFLooker>();
		player = GetComponent<LSFPlayer>();
	}

	// Update is called once per frame
	void Update () {
		Vector3 dir = Vector3.zero;
		if (mover != null)
		{
			dir.x = Input.GetAxis("L_XAxis_" + controllerId);
			dir.z = -Input.GetAxis("L_YAxis_" + controllerId);
			if (dir.sqrMagnitude > 0)
			{
				mover.Move(dir);
			}
		}

		if (looker != null)
		{
			dir = Vector3.zero;

	#if UNITY_EDITOR_OSX || UNITY_STANDALONE_OSX
			dir.x = Input.GetAxis("Triggers_" + controllerId);
			dir.y = -Input.GetAxis("R_XAxis_" + controllerId);
	#else
			dir.x = Input.GetAxis("R_XAxis_" + controllerId);
			dir.y = -Input.GetAxis("R_YAxis_" + controllerId);
	#endif
			if (dir.sqrMagnitude > 0)
			{
				looker.Look(dir);
			}
		}

		if ((Input.GetButtonDown("X_" + controllerId) || Input.GetButtonDown("Mac_X_" + controllerId)) && LSFWhiteboard.playersActive[0])
		{
			LSFMinionManager.instance.SetMinionTarget(0, player.playerIndex);
		}
		if ((Input.GetButtonDown("Y_" + controllerId) || Input.GetButtonDown("Mac_Y_" + controllerId)) && LSFWhiteboard.playersActive[0])
		{
			LSFMinionManager.instance.SetMinionTarget(1, player.playerIndex);
		}
		if ((Input.GetButtonDown("A_" + controllerId) || Input.GetButtonDown("Mac_A_" + controllerId)) && LSFWhiteboard.playersActive[0])
		{
			LSFMinionManager.instance.SetMinionTarget(2, player.playerIndex);
		}
		if ((Input.GetButtonDown("B_" + controllerId) || Input.GetButtonDown("Mac_B_" + controllerId)) && LSFWhiteboard.playersActive[0])
		{
			LSFMinionManager.instance.SetMinionTarget(3, player.playerIndex);
		}
	}
}
