﻿using UnityEngine;
using System.Collections;

/// <summary>
/// @author Rob Giusti
/// WASD movement for a LSFMover
/// </summary>
[RequireComponent (typeof(LSFMover))]
public class LSFKeyboardController : MonoBehaviour {

	LSFMover mover;

	void Awake()
	{
		mover = GetComponent<LSFMover>();
	}

	void Update()
	{
		if (mover == null) return;

		Vector3 moveDir = Vector3.zero;
		if (Input.GetKey(KeyCode.W))
		{
			Debug.Log("Up!");
			moveDir.z = 1;
		}
		else if (Input.GetKey(KeyCode.S))
		{
			moveDir.z = -1;
		}
		if (Input.GetKey(KeyCode.D))
		{
			moveDir.x = 1;
		}
		else if (Input.GetKey(KeyCode.A))
		{
			moveDir.x = -1;
		}
		moveDir.Normalize();

		if (moveDir.sqrMagnitude > 0)
		{
			mover.Move(moveDir);
		}
	}
}
