﻿using UnityEngine;
using System.Collections;

public class LSFCreepSpawner : MonoBehaviour{

    public static LSFCreepSpawner instance;

	[SerializeField]
	LSFCreepController creepPrefab;

	int distance = 3;

    int creepPerPoint = 6;

    void Awake()
    {
        instance = this;
    }

	public void SpawnCreep(Transform pos, int team){
		LSFCreepController creepObject = Instantiate(creepPrefab, pos.position, pos.rotation) as LSFCreepController;
		creepObject.team = team;
	}

	public void SpawnCreepsFromCP(Transform pos, int team, int num){

        LSFCreepController creep;
        for (int i = 0; i < num; i++)
        {
            float rad = i * 2 * Mathf.PI / creepPerPoint;
			creep = Instantiate(creepPrefab, pos.position + (distance * new Vector3(Mathf.Cos(rad), 0, Mathf.Sin(rad))), pos.rotation) as LSFCreepController;
			creep.originalTeam = team;
            creep.team = team;

            if (LSFEventManager.Minions.OnPlayerCaptureCreep != null)
            {
                LSFEventManager.Minions.OnPlayerCaptureCreep(creep);
            }
        }

        /*
		//0 degrees
		GameObject creepObject1 = (GameObject)Instantiate(prefab, pos.position + (distance * new Vector3(1, 0, 0)), pos.rotation);
		creepScript = creepObject1.GetComponent<LSFCreepController>();
		if (creepScript != null) {
			creepScript.team = team;
		}
		//60 degrees
		GameObject creepObject2 = (GameObject)Instantiate(prefab, pos.position + (distance * new Vector3(0.5f, 0, 0.866f)), pos.rotation);
		creepScript = creepObject2.GetComponent<LSFCreepController>();
		if (creepScript != null) {
			creepScript.team = team;
		}
		//120 degrees
		GameObject creepObject3 = (GameObject)Instantiate(prefab, pos.position + (distance * new Vector3(-0.5f, 0, 0.866f)), pos.rotation);
		creepScript = creepObject3.GetComponent<LSFCreepController>();
		if (creepScript != null) {
			creepScript.team = team;
		}
		//180 degrees
		GameObject creepObject4 = (GameObject)Instantiate(prefab, pos.position + (distance * new Vector3(-1, 0, 0)), pos.rotation);
		creepScript = creepObject4.GetComponent<LSFCreepController>();
		if (creepScript != null) {
			creepScript.team = team;
		}
		//240 degrees
		GameObject creepObject5 = (GameObject)Instantiate(prefab, pos.position + (distance * new Vector3(-0.5f, 0, -0.866f)), pos.rotation);
		creepScript = creepObject5.GetComponent<LSFCreepController>();
		if (creepScript != null) {
			creepScript.team = team;
		}
		//300 degrees
		GameObject creepObject6 = (GameObject)Instantiate(prefab, pos.position + (distance * new Vector3(0.5f, 0, -0.866f)), pos.rotation);
		creepScript = creepObject6.GetComponent<LSFCreepController>();
		if (creepScript != null) {
			creepScript.team = team;
		}
         */
	}
}
