using UnityEngine;
using System.Collections;

[RequireComponent (typeof (SpriteRenderer))]
[RequireComponent (typeof (LSFPlayer))]
public class LSFDimmer : MonoBehaviour {

	[SerializeField]
	float dimSum = .3f;

	public SpriteRenderer sprite;

	LSFPlayer player;

	bool _bright = true;

	public bool invuln;

	public bool dim
	{
		get
		{
			return !_bright;
		}
	}

	public bool bright
	{
		get
		{
			return _bright;
		}
		set
		{
			_bright = value;

			sprite.color = new Color(sprite.color.r, sprite.color.g, sprite.color.b, (_bright) ? 1 : dimSum);
		}
	}

	void Awake()
	{
		player = GetComponent<LSFPlayer>();
	}

	void Start()
	{
		Init();
	}

	void Init()
	{
		bright = false;
	}

	void OnTriggerEnter(Collider other)
	{
		if (bright) 
		{
			if (other.name == "DimmerPoint" && LSFMinionManager.instance.HasMinions(player.playerIndex)) 
			{
				bright = false;
			}
		} 
		else if (!invuln)
		{
			LSFFlashlight flashlight = other.GetComponent<LSFFlashlight> ();
			if (flashlight != null && flashlight.playerIndex != player.playerIndex
			    && flashlight.looker.CanHit(transform.position)) {
				bright = true;
				LSFEventManager.Minions.OnPlayerTagged(player.playerIndex, flashlight.playerIndex);
			}
		}
	}
	



}
