﻿using UnityEngine;
using System.Collections;
using System;

public class LSFLiving : MonoBehaviour {

	[SerializeField]
	int maxHp;

	int hp;

	public Action OnDeath;

	LSFPlayer player;

	LSFCreepController creep;

	int team
	{
		get
		{
			if (player != null)
			{
				return player.playerIndex;
			}
			if (creep != null)
			{
				return creep.team;
			}
			return -1;
		}
	}

	void Awake()
	{
		player = GetComponent<LSFPlayer>();
		creep = GetComponent<LSFCreepController>();
	}

	void Init()
	{
		hp = maxHp;
	}

	public void TakeDamage(int damage)
	{
		hp -= damage;
		if (hp <= 0)
		{
			if (OnDeath != null)
			{
				OnDeath();
			}
			else
			{
				Destroy(gameObject);
			}
		}
	}

	void OnTriggerEnter(Collider other)
	{
		LSFDealsDamage damager = other.GetComponent<LSFDealsDamage>();
		if (damager != null && damager.team != team)
		{
			TakeDamage(damager.damage);
		}
	}
}
