﻿using UnityEngine;
using System.Collections;

public class LSFMover : MonoBehaviour 
{
    [SerializeField]
    float baseSpeed = 360.0f;
    [SerializeField]
	float speed;

	Vector3 currDirection;

    public const float SPEED_BOOST_POWER = 2.0f;
    public const float SPEED_DIMINISH_RATE = 80.0f;

	[HideInInspector]
	public Rigidbody rig;

	void Awake()
	{
		rig = rigidbody;
        speed = baseSpeed;
	}

	public void Move(Vector3 direction)
	{
		currDirection = direction;
	}

	void LateUpdate()
	{
		//if (currDirection.sqrMagnitude > 0)
		//{
			//Debug.LogWarning("Moving dir: " + currDirection);
			//trans.localPosition += currDirection * speed * Time.deltaTime;
		//}
		rig.velocity = currDirection * speed * Time.deltaTime;
		currDirection = Vector3.zero;

        //If boosted, boost diminishes over time.
        if (speed > baseSpeed)
        {
            speed -= Time.deltaTime * SPEED_DIMINISH_RATE;
        }
        if (speed < baseSpeed)
        {
            speed = baseSpeed;
        }
	}

    //For hitting a speed boost.
    void OnTriggerEnter(Collider other)
    {
        if (other.name == "SpeedPoint")
        {
            speed = baseSpeed * SPEED_BOOST_POWER;
        }
    }
}
