﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class LSFCollisionCapture : MonoBehaviour {

	public float captureSpeed;
	public float cooldownSeconds;

    public int _owner = -1;

	private float currentCaptureLevel = 0;
	private Transform captureIndicator;
	private List<int> captureQueue;
	private bool cooldown = false;
	private float cooldownRate = 0.01666f;
    [SerializeField]
	private float currentCooldown;

	[SerializeField]
	int numCreeps;


	void Start () {
		captureIndicator = transform.FindChild ("CaptureSprite");
		captureQueue = new List<int> ();
		currentCooldown = cooldownSeconds;
	}

	void Update () {
		if (cooldown == true) {
			if (currentCooldown > 0) {
				currentCooldown -= cooldownRate;
			} else {
				cooldown = false;
				currentCooldown = cooldownSeconds;
			}
		}
		else if (captureQueue.Count == 1) {
			captureIndicator.GetComponent<SpriteRenderer> ().color = LSFColors.captureColors[captureQueue [0]];
			if (currentCaptureLevel < 3.0f) {
					currentCaptureLevel += captureSpeed;
					Vector3 localScale = captureIndicator.localScale;
					localScale.x = currentCaptureLevel;
					localScale.y = currentCaptureLevel;
					localScale.z = currentCaptureLevel;
					captureIndicator.localScale = localScale;
			}
			else{
				SpawnCreeps();
			}
		} 
	else if (captureQueue.Count > 1) {

		}
	
	}

	void ClearCapture(){
		Vector3 localScale = captureIndicator.localScale;
		localScale.x = 0;
		localScale.y = 0;
		localScale.z = 0;
		captureIndicator.localScale = localScale;
		currentCaptureLevel = 0;
	}

	void SpawnCreeps(){
		if (captureQueue.Count == 1) {
			LSFCreepSpawner.instance.SpawnCreepsFromCP(transform, captureQueue[0], numCreeps);
			ClearCapture();
			cooldown = true;
		}
	}

	void OnTriggerEnter(Collider collider){
		LSFPlayer playerScript = collider.GetComponent<LSFPlayer>();
		if (playerScript != null) {

		//print (collider.gameObject.name + " Entered");
			captureQueue.Add (playerScript.playerIndex);
		}

	}

	void OnTriggerExit(Collider collider){
		LSFPlayer playerScript = collider.GetComponent<LSFPlayer>();
		if (playerScript != null) {


			//print (collider.gameObject.name + " Exited");
			if (captureQueue [0] == playerScript.playerIndex) {
					ClearCapture ();
			}
			captureQueue.Remove (playerScript.playerIndex);
		}
	}
}
