﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;


/// <summary>
/// Standard event manager to control event firing.
/// </summary>
public static class LSFEventManager 
{
    public static class UI
    {
        public static Action<Vector3, Color, string> CreatePopup;
    }

	public static class Minions
	{
		public static Action<LSFCreepController> OnPlayerCaptureCreep;
		public static Action<LSFCreepController> OnMinionDie;

		/// <summary>
		/// Called when a player is tagged by another player, turning all of their creeps
		/// First int is the tagged player, second int is the tagger
		/// </summary>
		public static Action<int, int> OnPlayerTagged;

		public static Action<int> OnPlayerDim;

		public static Action<int> OnPlayerDeath;
	}
}
