﻿using UnityEngine;
using System.Collections;

public class LSFPopup : MonoBehaviour 
{
    public GameObject pre_Popup;

    private Transform _popupTransform;
    private UILabel _popupText;
    private TweenPosition _popupPosTween;
    private TweenAlpha _popupAlphaTween;

    void Awake()
    {
    }

    void OnEnable()
    {
        LSFEventManager.UI.CreatePopup += CreatePopup;
    }

    void OnDisable()
    {
        LSFEventManager.UI.CreatePopup -= CreatePopup;
    }

    void CreatePopup(Vector3 loc, Color color, string text)
    {
        GameObject newPopup = Instantiate(pre_Popup, loc, Quaternion.identity) as GameObject;

        _popupTransform = newPopup.transform;
        _popupText = newPopup.GetComponent<UILabel>();
        _popupPosTween = newPopup.GetComponent<TweenPosition>();
        _popupAlphaTween = newPopup.GetComponent<TweenAlpha>();

        _popupTransform.parent = transform;
        _popupTransform.localPosition = loc;
        _popupTransform.localScale = Vector3.one;

        _popupText.text = text;
        _popupText.color = color;

        _popupPosTween.from = _popupTransform.localPosition;
        _popupPosTween.to = new Vector3(_popupTransform.localPosition.x, _popupTransform.localPosition.y + 10, 0);
        EventDelegate.Add(_popupAlphaTween.onFinished, KillPopup);


        _popupPosTween.PlayForward();
        _popupAlphaTween.PlayForward();
    }

    void KillPopup()
    {
        Destroy(UITweener.current.gameObject);
    }
}
