﻿using UnityEngine;
using System.Collections;

public class LSFSelection : MonoBehaviour 
{
    private int _counter = 0;

    public UILabel startNotifier;
    public LSFMonolith[] _playerMonoliths = new LSFMonolith[4];

    static Color PLAYER_1_ONLINE_COLOR = new Color(0, 1, 0);
    static Color PLAYER_2_ONLINE_COLOR = new Color(0, 0, 1);
    static Color PLAYER_3_ONLINE_COLOR = new Color(1, 1, 0);
    static Color PLAYER_4_ONLINE_COLOR = new Color(1, 0, 0);
    static Color PLAYER_OFFLINE_COLOR = new Color(1f, 1f, 1f, 0.5f);

    void Start()
    {
        foreach (LSFMonolith monolith in _playerMonoliths)
        {
            monolith.status.text = "OFFLINE";
            monolith.background.color = PLAYER_OFFLINE_COLOR;
        }

        for (int i = 0; i <= 3; i++)
        {
            LSFWhiteboard.playersActive[i] = false;
            _playerMonoliths[i].status.text = "OFFLINE";
            _playerMonoliths[i].background.color = PLAYER_OFFLINE_COLOR;
        }
    }

	void Update() 
    {
        if (Input.GetButtonDown("A_1"))
        {
            Debug.Log("Player 1");
            if (LSFWhiteboard.playersActive[0] == false)
            {
                LSFWhiteboard.playersActive[0] = true;
                _playerMonoliths[0].status.text = "ONLINE";
                _playerMonoliths[0].background.color = PLAYER_1_ONLINE_COLOR;
                _counter++;
            }
            else
            {
                LSFWhiteboard.playersActive[0] = false;
                _playerMonoliths[0].status.text = "OFFLINE";
                _playerMonoliths[0].background.color = PLAYER_OFFLINE_COLOR;
                _counter--;
            }
        }
        else if (Input.GetButtonDown("A_2"))
        {
            Debug.Log("Player 2");
            if (LSFWhiteboard.playersActive[1] == false)
            {
                LSFWhiteboard.playersActive[1] = true;
                _playerMonoliths[1].status.text = "ONLINE";
                _playerMonoliths[1].background.color = PLAYER_2_ONLINE_COLOR;
                _counter++;
            }
            else
            {
                LSFWhiteboard.playersActive[1] = false;
                _playerMonoliths[1].status.text = "OFFLINE";
                _playerMonoliths[1].background.color = PLAYER_OFFLINE_COLOR;
                _counter--;
            }
        }
        else if (Input.GetButtonDown("A_3"))
        {

            Debug.Log("Player 3");
            if (LSFWhiteboard.playersActive[2] == false)
            {
                LSFWhiteboard.playersActive[2] = true;
                _playerMonoliths[2].status.text = "ONLINE";
                _playerMonoliths[2].background.color = PLAYER_3_ONLINE_COLOR;
                _counter++;
            }
            else
            {
                LSFWhiteboard.playersActive[2] = false;
                _playerMonoliths[2].status.text = "OFFLINE";
                _playerMonoliths[2].background.color = PLAYER_OFFLINE_COLOR;
                _counter--;
            }
        }
        else if (Input.GetButtonDown("A_4"))
        {

            Debug.Log("Player 4");
            if (LSFWhiteboard.playersActive[3] == false)
            {
                LSFWhiteboard.playersActive[3] = true;
                _playerMonoliths[3].status.text = "ONLINE";
                _playerMonoliths[3].background.color = PLAYER_4_ONLINE_COLOR;
                _counter++;
            }
            else
            {
                LSFWhiteboard.playersActive[3] = false;
                _playerMonoliths[3].status.text = "OFFLINE";
                _playerMonoliths[3].background.color = PLAYER_OFFLINE_COLOR;
                _counter--;
            }
        }

        if (_counter >= 2)
        {
            startNotifier.enabled = true;
            if (Input.GetButtonDown("Start_1") || Input.GetButtonDown("Start_2") 
                || Input.GetButtonDown("Start_3") || Input.GetButtonDown("Start_4"))
            {
                Application.LoadLevel(2);
            }
        }
        else
        {
            startNotifier.enabled = false;
        }

        Debug.Log(_counter);
	}
}
